Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking.Views/3.3/Container3DView.xaml.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking.Views/3.3/Container3DView.xaml.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking.Views/3.3/Container3DView.xaml.cs	(revision 15554)
@@ -74,5 +74,5 @@
     private Dictionary<int, DiffuseMaterial> materials;
 
-    public ObservableDictionary<BinPacking3D.PackingPosition, ResidualSpace> ResidualSpaces { get; set; }
+    public ObservableDictionary<BinPacking3D.PackingPosition, IList<ResidualSpace>> ResidualSpaces { get; set; }
     public ObservableCollection<BinPacking3D.PackingPosition> ExtremePoints { get; set; }
 
@@ -81,5 +81,5 @@
       camMain.Position = new Point3D(0.5, 3, 3); // for design time we use a different camera position 
       materials = new Dictionary<int, DiffuseMaterial>();
-      ResidualSpaces = new ObservableDictionary<BinPacking3D.PackingPosition, ResidualSpace>();
+      ResidualSpaces = new ObservableDictionary<BinPacking3D.PackingPosition, IList<ResidualSpace>>();
       ExtremePoints = new ObservableCollection<BinPacking3D.PackingPosition>();
       selectedExtremePointIndex = -1;
@@ -240,17 +240,19 @@
     private void AddResidualSpacesForExtremePoint(Model3DGroup modelGroup, BinPacking3D.PackingPosition extremePoint) {
       if (showResidualSpaces) {
-        var rs = ResidualSpaces[extremePoint];
-        var containerModel1 = new GeometryModel3D(new MeshGeometry3D(), new DiffuseMaterial(new SolidColorBrush(residualSpaceColor)));
-
-        modelGroup.Children.Add(containerModel1);
-        AddWireframeCube((MeshGeometry3D)containerModel1.Geometry,
-          extremePoint.X,
-          extremePoint.Y,
-          extremePoint.Z,
-          rs.Width,
-          rs.Height,
-          rs.Depth);
-
+        foreach (var rs in ResidualSpaces[extremePoint]) {
+          var containerModel1 = new GeometryModel3D(new MeshGeometry3D(), new DiffuseMaterial(new SolidColorBrush(residualSpaceColor)));
+
+          modelGroup.Children.Add(containerModel1);
+
+          AddWireframeCube((MeshGeometry3D)containerModel1.Geometry,
+            extremePoint.X,
+            extremePoint.Y,
+            extremePoint.Z,
+            rs.Width,
+            rs.Height,
+            rs.Depth);
+        }
       }
+       
     }
 
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlan3DView.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlan3DView.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlan3DView.cs	(revision 15554)
@@ -24,4 +24,5 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.Problems.BinPacking3D;
+using System.Collections.Generic;
 
 namespace HeuristicLab.Problems.BinPacking.Views {
@@ -75,9 +76,9 @@
         itemSelection.Items.Add(item.Key);
       }
-      foreach (var ep in ((BinPacking3D.BinPacking3D)packing).ExtremePoints) {
-        var rs = ((BinPacking3D.BinPacking3D)packing).ResidualSpaces[ep];
+      foreach (var extremPoint in ((BinPacking3D.BinPacking3D)packing).ExtremePoints) {
+        var ep = extremPoint.Key;
         extremePointsSelection.Items.Add($"({ep.X}, {ep.Y}, {ep.Z})");
         packingPlan3D.ExtremePoints.Add(ep);
-        packingPlan3D.ResidualSpaces.Add(ep, rs);
+        packingPlan3D.ResidualSpaces.Add(ep, extremPoint.Value as IList<ResidualSpace>);
       }
 
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/BinPacking3D.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/BinPacking3D.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/BinPacking3D.cs	(revision 15554)
@@ -34,19 +34,14 @@
   [StorableClass]
   public class BinPacking3D : BinPacking<PackingPosition, PackingShape, PackingItem> {
-
+    
     [Storable]
-    public Dictionary<PackingPosition, ResidualSpace> ResidualSpaces { get; set; }
-
-    [Storable]
-    public SortedSet<PackingPosition> ExtremePoints { get; protected set; }
+    public IDictionary<PackingPosition, IEnumerable<ResidualSpace>> ExtremePoints { get; protected set; }
 
 
     public BinPacking3D(PackingShape binShape)
       : base(binShape) {
-      ExtremePoints = new SortedSet<PackingPosition>();
-      ResidualSpaces = new Dictionary<PackingPosition, ResidualSpace>();
+      ExtremePoints = new SortedList<PackingPosition, IEnumerable<ResidualSpace>>();
       
-      ExtremePoints.Add(binShape.Origin);
-      ResidualSpaces.Add(binShape.Origin, new ResidualSpace(BinShape.Width, BinShape.Height, BinShape.Depth));
+      ExtremePoints.Add(binShape.Origin, new List<ResidualSpace>() {ResidualSpace.Create(binShape.Width, binShape.Height, binShape.Depth)});
     }
 
@@ -56,9 +51,13 @@
     protected BinPacking3D(BinPacking3D original, Cloner cloner)
       : base(original, cloner) {
-      this.ResidualSpaces = new Dictionary<PackingPosition, ResidualSpace>();
-      foreach (var o in original.ResidualSpaces)
-        this.ResidualSpaces.Add(cloner.Clone(o.Key), ResidualSpace.Create(o.Value));
-
-      this.ExtremePoints = new SortedSet<PackingPosition>(original.ExtremePoints.Select(p => cloner.Clone(p)));
+
+      this.ExtremePoints = new SortedList<PackingPosition, IEnumerable<ResidualSpace>>();
+      foreach (var extremePoint in original.ExtremePoints) {
+        var residualSpaces = new List<ResidualSpace>();
+        foreach (var residualSpace in extremePoint.Value) {
+          residualSpaces.Add(cloner.Clone(residualSpace));
+        }
+        ExtremePoints.Add(cloner.Clone(extremePoint.Key), residualSpaces);
+      }
     }
 
@@ -67,16 +66,5 @@
     }
 
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      // BackwardsCompatibility3.3
-      #region Backwards compatible code, remove with 3.4
-      if (ResidualSpaces == null)
-        ResidualSpaces = new Dictionary<PackingPosition, ResidualSpace>();
-      #endregion
-    }
-
-
-
+    
 
     /// <summary>
@@ -90,5 +78,4 @@
       Positions[itemID] = position;
       ExtremePoints.Remove(position);
-      ResidualSpaces.Remove(position);
     }
 
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/ExtremePointCreator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/ExtremePointCreator.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ExtremePointCreation/ExtremePointCreator.cs	(revision 15554)
@@ -46,7 +46,7 @@
         // Projecting onto the XZ-plane
         var below = ProjectDown(binPacking, sourcePoint);
-        var residualSpace = CalculateResidualSpace(binPacking, below);
-        if (!residualSpace.IsZero()
-          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, below, residualSpace)) {
+        var residualSpaces = CalculateResidualSpace(binPacking, below);
+        if (residualSpaces.Count() > 0
+          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, below, residualSpaces)) {
           // add only if the projected point's residual space is not a sub-space
           // of another extreme point's residual space
@@ -56,7 +56,7 @@
         // Projecting onto the XY-plane
         var back = ProjectBackward(binPacking, sourcePoint);
-        residualSpace = CalculateResidualSpace(binPacking, back);
-        if (!residualSpace.IsZero()
-          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, back, residualSpace)) {
+        residualSpaces = CalculateResidualSpace(binPacking, back);
+        if (residualSpaces.Count() > 0
+          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, back, residualSpaces)) {
           // add only if the projected point's residual space is not a sub-space
           // of another extreme point's residual space
@@ -71,7 +71,7 @@
         // Projecting onto the YZ-plane
         var left = ProjectLeft(binPacking, sourcePoint);
-        var residualSpace = CalculateResidualSpace(binPacking, left);
-        if (!residualSpace.IsZero()
-          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, left, residualSpace)) {
+        var residualSpaces = CalculateResidualSpace(binPacking, left);
+        if (residualSpaces.Count() > 0
+          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, left, residualSpaces)) {
           // add only if the projected point's residual space is not a sub-space
           // of another extreme point's residual space
@@ -81,7 +81,7 @@
         // Projecting onto the XY-plane
         var back = ProjectBackward(binPacking, sourcePoint);
-        residualSpace = CalculateResidualSpace(binPacking, back);
-        if (!residualSpace.IsZero()
-          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, back, residualSpace)) {
+        residualSpaces = CalculateResidualSpace(binPacking, back);
+        if (residualSpaces.Count() > 0
+          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, back, residualSpaces)) {
           // add only if the projected point's residual space is not a sub-space
           // of another extreme point's residual space
@@ -96,7 +96,7 @@
         // Projecting onto the XZ-plane
         var below = ProjectDown(binPacking, sourcePoint);
-        var residualSpace = CalculateResidualSpace(binPacking, below);
-        if (!residualSpace.IsZero()
-          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, below, residualSpace)) {
+        var residualSpaces = CalculateResidualSpace(binPacking, below);
+        if (residualSpaces.Count() > 0
+          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, below, residualSpaces)) {
           // add only if the projected point's residual space is not a sub-space
           // of another extreme point's residual space
@@ -106,7 +106,7 @@
         // Projecting onto the YZ-plane
         var left = ProjectLeft(binPacking, sourcePoint);
-        residualSpace = CalculateResidualSpace(binPacking, left);
-        if (!residualSpace.IsZero()
-          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, left, residualSpace)) {
+        residualSpaces = CalculateResidualSpace(binPacking, left);
+        if (residualSpaces.Count() > 0
+          && !IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, left, residualSpaces)) {
           // add only if the projected point's residual space is not a sub-space
           // of another extreme point's residual space
@@ -191,7 +191,36 @@
     /// <param name="residualSpace"></param>
     /// <returns></returns>
-    protected virtual bool IsWithinResidualSpaceOfAnotherExtremePoint(BinPacking3D binPacking, Vector3D pos, ResidualSpace residualSpace) {
-      var eps = binPacking.ExtremePoints.Where(x => !pos.Equals(x) && pos.IsInside(x, binPacking.ResidualSpaces[x]));
-      return eps.Any(x => IsWithinResidualSpaceOfAnotherExtremePoint(pos, residualSpace, x, binPacking.ResidualSpaces[x]));
+    protected bool IsWithinResidualSpaceOfAnotherExtremePoint(BinPacking3D binPacking, Vector3D pos, ResidualSpace residualSpace) {
+      var eps = binPacking.ExtremePoints.Where(x => !pos.Equals(x.Key) && pos.IsInside(x.Key, x.Value));
+      return eps.Any(x => IsWithinResidualSpaceOfAnotherExtremePoint(pos, residualSpace, x.Key, x.Value));
+    }
+
+    /// <summary>
+    /// 
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="pos"></param>
+    /// <param name="residualSpaces"></param>
+    /// <returns></returns>
+    protected bool IsWithinResidualSpaceOfAnotherExtremePoint(BinPacking3D binPacking, Vector3D pos, IEnumerable<ResidualSpace> residualSpaces) {
+      foreach (var residualSpace in residualSpaces) {
+        if (IsWithinResidualSpaceOfAnotherExtremePoint(binPacking, pos, residualSpace)) {
+          return true;
+        }
+      }
+      return false;
+    }
+
+
+    /// <summary>
+    /// Returns true, if the given poisition and the related residual space is within the residual space of the given extreme point
+    /// </summary>
+    /// <param name="pos"></param>
+    /// <param name="rsPos"></param>
+    /// <param name="ep"></param>
+    /// <param name="rsEp"></param>
+    /// <returns></returns>
+    protected bool IsWithinResidualSpaceOfAnotherExtremePoint(Vector3D pos, ResidualSpace rsPos, PackingPosition ep, IEnumerable<ResidualSpace> rsEp) {
+      return rsEp.Any(x => IsWithinResidualSpaceOfAnotherExtremePoint(pos, rsPos, ep, x));
     }
 
@@ -211,51 +240,12 @@
 
     /// <summary>
-    /// Calculates the residual space for a given bin packing and position.
-    /// It returns the residual space as a tuple which contains the dimensions
-    /// </summary>
-    /// <param name="binPacking"></param>
-    /// <param name="pos"></param>
-    /// <returns>A Tuple(width, Height, Depth)</width></returns>
-    protected virtual ResidualSpace CalculateResidualSpace(BinPacking3D binPacking, Vector3D pos) {
-      //return ResidualSpaceCalculator.Create().CalculateResidualSpace(binPacking, pos).First();
-      return new ResidualSpace(CalculateResidualSpaceOld(binPacking, pos));
-    }
-
-    protected virtual Tuple<int, int, int> CalculateResidualSpaceOld(BinPacking3D binPacking, Vector3D pos) {
-
-      if (pos == null) {
-        return Tuple.Create(0, 0, 0);
-      }
-      var itemPos = binPacking.Items.Select(x => new {
-        Item = x.Value,
-        Position = binPacking.Positions[x.Key]
-      });
-      Vector3D limit = new Vector3D() {
-        X = binPacking.BinShape.Width,
-        Y = binPacking.BinShape.Height,
-        Z = binPacking.BinShape.Depth
-      };
-
-      if (pos.X < limit.X && pos.Y < limit.Y && pos.Z < limit.Z) {
-        var rightLimit = ProjectRight(binPacking, pos);
-        var upLimit = ProjectUp(binPacking, pos);
-        var forwardLimit = ProjectForward(binPacking, pos);
-        if (rightLimit.X > 0) {
-          limit.X = rightLimit.X;
-        }
-        if (upLimit.Y > 0) {
-          limit.Y = upLimit.Y;
-        }
-        if (forwardLimit.Z > 0) {
-          limit.Z = forwardLimit.Z;
-        }
-      }
-
-      if (limit.X - pos.X <= 0 || limit.Y - pos.Y <= 0 || limit.Z - pos.Z <= 0) {
-        return Tuple.Create(0, 0, 0);
-      }
-      return Tuple.Create(limit.X - pos.X, limit.Y - pos.Y, limit.Z - pos.Z);
-    }
-
+    /// Calculates the residual spaces for a given bin packing and position.
+    /// It returns a collection of residual spaces
+    /// </summary>
+    /// <param name="binPacking"></param>
+    /// <param name="pos"></param>
+    /// <returns></returns>
+    protected abstract IEnumerable<ResidualSpace> CalculateResidualSpace(BinPacking3D binPacking, Vector3D pos);
+    
     #endregion
 
